<template>
  <b-container class="large-container">
    <!--
      We display a special graphic if the user is not logged in,
      or if they haven't marked any favorites yet.
    -->
    <div v-if="!isAuthenticated || status === Status.EMPTY">
      <div class="d-flex justify-content-center no-content">
        <img
          class="mr-4"
          src="../assets/favorite-loci-banner.svg"
        >
        <div
          class="d-flex flex-column text-justify ml-4"
          style="max-width: 400px;"
        >
          <h1>Save Objects of Interest</h1>
          <span>ANTARES allows you to save objects that you're studying so you can easily find them
            later.</span>
          <b-button
            v-if="status === Status.EMPTY"
            :to="{ name: 'home' }"
            class="mt-4"
            variant="primary"
          >
            <span>You don't have any favorites yet. Start searching.</span>
          </b-button>
          <b-button
            v-else
            :to="{ name: 'login', query: { redirect: $route.fullPath } }"
            class="mt-4"
            variant="primary"
          >
            <span>Login to view your favorite data.</span>
          </b-button>
        </div>
      </div>
    </div>
    <!--
      Otherwise, we use a larger container to display the table of loci
      or an error message--if there was a problem loading their favorites.
    -->
    <div v-else>
      <h1>Favorite Objects</h1>
      <div v-if="status === Status.LOADING">
        <content-loader-list-group
          :num-items="pending.page.limit"
          :width="1200"
        />
      </div>
      <div v-else-if="status === Status.ERROR">
        <b-list-group>
          <b-list-group-item variant="danger">
            <h5>There was a Problem Loading Your Favorites</h5>
          </b-list-group-item>
        </b-list-group>
      </div>
      <div v-else-if="status === Status.SUCCESS">
        <b-row>
          <b-col>
            <b-list-group>
              <locus-summary
                v-for="locus in loci"
                :key="locus.id"
                :locus="locus"
                @unfavorited="fetchLoci"
              />
            </b-list-group>
            <b-row
              align-h="between"
              class="mt-2"
            >
              <b-col>
                <b-row>
                  <b-col>
                    <b-form inline>
                      <label class="mr-2">Show</label>
                      <b-form-select
                        :options="pageOptions"
                        :value="active.page.limit"
                        class="mr-2"
                        @input="paginate($event, 1)"
                      />
                      <label class="mr-1">entries</label>
                    </b-form>
                  </b-col>
                </b-row>
                <b-row>
                  <b-col>
                    <span class="font-weight-lighter">
                      Showing {{ pageStart }} to {{ pageEnd }} of {{ lociCount }} entries
                    </span>
                  </b-col>
                </b-row>
              </b-col>

              <b-col>
                <b-pagination
                  :per-page="active.page.limit"
                  :total-rows="lociCount"
                  :value="pageCurrent"
                  align="right"
                  @change="paginate(active.page.limit, $event)"
                />
              </b-col>
            </b-row>
          </b-col>
        </b-row>
      </div>
    </div>
  </b-container>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapGetters } from 'vuex';
import { UserService } from '@/api';
import { LocusListing, RequestQuery } from '@/common/types';
import ContentLoaderListGroup from '@/components/ContentLoaderListGroup.vue';
import LocusSummary from '@/components/LocusSummary.vue';

/* eslint-disable-next-line no-shadow */
enum Status {
  EMPTY = 'EMPTY', // Like success but no results returned
  ERROR = 'ERROR',
  LOADING = 'LOADING',
  SUCCESS = 'SUCCESS',
}

export default Vue.extend({
  components: {
    ContentLoaderListGroup,
    LocusSummary,
  },

  data() {
    return {
      Status,
      active: {
        page: {
          limit: 5,
          offset: 0,
        },
      },
      loading: true,
      loci: [] as LocusListing,
      lociCount: 0,
      pageCurrent: 1,
      pageOptions: [5, 10, 25, 50, 100],
      pending: {
        page: {
          limit: 5,
          offset: 0,
        },
      },
      status: Status.LOADING,
    };
  },

  computed: {
    ...mapGetters(['isAuthenticated', 'user']),
    pageStart(): number {
      return (this.pageCurrent - 1) * this.active.page.limit + 1;
    },
    pageEnd(): number {
      const pageEnd = this.pageStart + this.active.page.limit - 1;
      return pageEnd > this.lociCount ? this.lociCount : pageEnd;
    },
    pendingQuery(): Partial<RequestQuery> {
      return {
        page: this.pending.page,
      };
    },
    activeQuery(): Partial<RequestQuery> {
      return {
        page: this.active.page,
      };
    },
  },

  mounted() {
    this.fetchLoci();
  },

  methods: {
    async fetchLoci() {
      this.status = Status.LOADING;
      try {
        const { data: loci } = await UserService.getFavoriteLoci(
          this.user.id,
          this.pendingQuery,
        );
        this.loci = loci;
        this.lociCount = loci.length;
        this.active = { ...this.pending };
        if (this.lociCount === 0) {
          this.status = Status.EMPTY;
        } else {
          this.status = Status.SUCCESS;
        }
      } catch (error) {
        this.status = Status.ERROR;
      }
    },

    async paginate(limit: number, page: number): Promise<void> {
      this.status = Status.LOADING;
      try {
        this.pending.page = { limit, offset: (page - 1) * limit };
        const { data: loci, meta } = await UserService.getFavoriteLoci(
          this.user.id,
          this.pendingQuery,
        );
        this.loci = loci;
        this.lociCount = meta.count;
        this.active = { ...this.pending };
        this.pageCurrent = page;
        this.status = Status.SUCCESS;
      } catch (error) {
        this.status = Status.ERROR;
      }
    },
  },
});
</script>

<style scoped>
.no-content {
  margin-top: 100px;
}
</style>
